
#ifndef _WINRT_DLL
	#include "stdafx.h"
#endif

#include <string.h>

#include "Effect.h"

///////////////////////////////////////////////////////////////////////////////
//
//
CEffect::CEffect(void)
{
}

///////////////////////////////////////////////////////////////////////////////
//
//
CEffect::~CEffect(void)
{
}

///////////////////////////////////////////////////////////////////////////////
//
//
void CEffect::ApplygGrayscale(BYTE * pBytes, int iLength)
{
	unsigned int* pEnd = (unsigned int*)(pBytes + iLength);

	// 4 bytes
	// ARGB
	// 

	for (unsigned int* p = (unsigned int*) pBytes; p < pEnd; p++)
	{
		unsigned int average = (((*p & 255) + ((*p >> 8) & 255) + ((*p >> 16) & 255)) / 3);
		*p = (average + (average << 8) + (average << 16) + ((*p >> 24) << 24));
	}
}


///////////////////////////////////////////////////////////////////////////////
//
//
void CEffect::ApplyBrightnessScale(BYTE * pBytes, int iLength, int iBrightness)
{
	unsigned int* pEnd = (unsigned int*)(pBytes + iLength);

	BYTE r, g, b;

	// 4 bytes
	// ARGB
	// 

	for (unsigned int* p = (unsigned int*) pBytes; p < pEnd; p++)
	{
		r = max(0, min(((*p)       & 255) + iBrightness, 255));
		g = max(0, min(((*p >> 8)  & 255) + iBrightness, 255));
		b = max(0, min(((*p >> 16) & 255) + iBrightness, 255));

		*p = (r + (g << 8) + (b << 16) + ((*p >> 24) << 24));
	}
}

///////////////////////////////////////////////////////////////////////////////
//
//
char * CEffect::GetEngineVersion(char* pszExtension)
{
	char *pszRet = UNKNOWN_ENGINE_VERSION;

	if(pszExtension != NULL && !_stricmp(pszExtension, PNG_EXTENSION))
		pszRet = EFFECT_ENGINE_VERSION;

	return pszRet;
}