
// SimpleImageViewDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SimpleImageView.h"
#include "SimpleImageViewDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

///////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
//
class CAboutDlg : public CDialogEx
{

public:

	CAboutDlg();

	// Dialog Data
	//
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
//
protected:
	DECLARE_MESSAGE_MAP()
};

///////////////////////////////////////////////////////////////////////////////
//
//
CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

///////////////////////////////////////////////////////////////////////////////
//
//
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

///////////////////////////////////////////////////////////////////////////////
//
//
BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////
//
//
CSimpleImageViewDlg::CSimpleImageViewDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CSimpleImageViewDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

///////////////////////////////////////////////////////////////////////////////
//
//
void CSimpleImageViewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER_BRIGHTNESS, m_SliderBrightness);
}

///////////////////////////////////////////////////////////////////////////////
//
//
BEGIN_MESSAGE_MAP(CSimpleImageViewDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LOAD_IMAGE,        &CSimpleImageViewDlg::OnBnClickedLoadImage)
	ON_BN_CLICKED(IDC_GRAY_SCALE,        &CSimpleImageViewDlg::OnBnClickedGrayScale)
	ON_BN_CLICKED(IDC_BRIGHTNESS_SCALE,  &CSimpleImageViewDlg::OnBnClickedBrightnessScale)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_ENGINE_VERSION,    &CSimpleImageViewDlg::OnBnClickedEngineVersion)
END_MESSAGE_MAP()


///////////////////////////////////////////////////////////////////////////////
//
//
BOOL CSimpleImageViewDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	//
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);

	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
	
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	//
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	//
	m_SliderBrightness.SetRange(0, 255);
	m_SliderBrightness.SetPos(127);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

///////////////////////////////////////////////////////////////////////////////
//
//
void CSimpleImageViewDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

///////////////////////////////////////////////////////////////////////////////
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
//
void CSimpleImageViewDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		//
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		
		CRect rect;
		
		GetClientRect(&rect);
		
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		//
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		if(m_Image.IsNull())
			return;

		CPaintDC dc(this); // device context for painting
		CRect showRect;
		showRect = CRect(1, 1, m_Image.GetWidth() + 1, m_Image.GetHeight() + 1);
		m_Image.Draw(dc, CRect(&showRect));

		CDialogEx::OnPaint();
	}
}

///////////////////////////////////////////////////////////////////////////////
// The system calls this function to obtain the cursor to display while the user drags
// the minimized window.
//
HCURSOR CSimpleImageViewDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


///////////////////////////////////////////////////////////////////////////////
//
//
void CSimpleImageViewDlg::OnBnClickedLoadImage()
{
	TRY
	{
		TCHAR szPath[_MAX_PATH];
		*szPath = '\0';

		GetCurrentDirectory(_MAX_PATH, szPath);
		CString sImageFileName(szPath);

		sImageFileName.Append(_T("\\logo.png"));

		if(!m_Image.IsNull())
			m_Image.Destroy();

		m_Image.Load(sImageFileName);
		
		Invalidate();
	}
	CATCH(CException, e)
	{
	}
	END_CATCH

}

///////////////////////////////////////////////////////////////////////////////
//
//
void CSimpleImageViewDlg::OnBnClickedGrayScale()
{
	if(m_Image.IsNull())
		return;

	// Top-Down vs. Bottom-Up DIBs
	// http://msdn.microsoft.com/en-us/library/ms787796.aspx
	//
	BYTE *	pSource = (BYTE *)m_Image.GetBits();
	int     iPitch  = m_Image.GetPitch();
	int		iLength = abs(iPitch) * (m_Image.GetHeight() - 1);

	if(iPitch < 0) 
		pSource -= iLength;
	
	m_Effect.ApplygGrayscale(pSource, iLength);

	Invalidate();
}

///////////////////////////////////////////////////////////////////////////////
//
//
void CSimpleImageViewDlg::OnBnClickedBrightnessScale()
{
	OnBnClickedLoadImage();

	if(m_Image.IsNull())
		return;

	// Top-Down vs. Bottom-Up DIBs
	// http://msdn.microsoft.com/en-us/library/ms787796.aspx
	//
	BYTE *	pSource = (BYTE *)m_Image.GetBits();
	int     iPitch  = m_Image.GetPitch();
	int		iLength = abs(iPitch) * (m_Image.GetHeight() - 1);

	if(iPitch < 0) 
		pSource -= iLength;

	m_Effect.ApplyBrightnessScale(pSource, 
								  iLength,
								  m_SliderBrightness.GetPos());

	Invalidate();
}

///////////////////////////////////////////////////////////////////////////////
//
//
void CSimpleImageViewDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if(nSBCode == TB_THUMBPOSITION)
		OnBnClickedBrightnessScale();

	CDialogEx::OnHScroll(nSBCode, nPos, pScrollBar);
}


///////////////////////////////////////////////////////////////////////////////
//
//
void CSimpleImageViewDlg::OnBnClickedEngineVersion()
{
	AfxMessageBox(CString::CStringT(m_Effect.GetEngineVersion("png")));
}
