﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using ImageEffectsWP8;
using Windows.UI.Xaml.Media.Imaging;
using Windows.Storage;
using Windows.Storage.Streams;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=391641

namespace SimpleImageViewWP8
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        Lazy<PictureService> ImageService {get;set;}

        public MainPage()
        {
            this.InitializeComponent();

            this.NavigationCacheMode = NavigationCacheMode.Required;

            ImageService = new Lazy<PictureService>();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.
        /// This parameter is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            // TODO: Prepare page for display here.

            // TODO: If your application contains multiple pages, ensure that you are
            // handling the hardware Back button by registering for the
            // Windows.Phone.UI.Input.HardwareButtons.BackPressed event.
            // If you are using the NavigationHelper provided by some templates,
            // this event is handled for you.
        }

        /// <summary>
        /// Handles the Click event of the btnLoad control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void btnLoad_Click(object sender, RoutedEventArgs e)
        {
            imgLogo.Source = new BitmapImage(new Uri(string.Format("ms-appx:///Assets/{0}", App.ImageFileName)));
        }

        /// <summary>
        /// Handles the Click event of the btnGrayscale control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void btnGrayscale_Click(object sender, RoutedEventArgs e)
        {
            ImageService.Value.ToGrayScale(imgLogo);
        }

        /// <summary>
        /// Handles the Click event of the btnBright control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void btnBright_Click(object sender, RoutedEventArgs e)
        {
            ImageService.Value.ApplyBrightnessScale(imgLogo, (int)slBright.Value);
        }


        /// <summary>
        /// Handles the ValueChanged event of the slBright control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RangeBaseValueChangedEventArgs"/> instance containing the event data.</param>
        private void slBright_ValueChanged(object sender, RangeBaseValueChangedEventArgs e)
        {
            if(slBright == null)
                return;

            btnBright_Click(this, null);
        }


        /// <summary>
        /// Handles the Click event of the btnVersion control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="RoutedEventArgs"/> instance containing the event data.</param>
        private void btnVersion_Click(object sender, RoutedEventArgs e)
        {
            App.ShowMessage(ImageService.Value.GetPngEngineVersion(), "Message");
        }


    }
}
